<!doctype html>
<html lang="en">

  <head>
    <meta charset="utf-8">

    <title>boost::any && boost::string_ref</title>

    <meta name="description" content="A presentation on boost::any and boost::string_ref">
    <meta name="author" content="Benjamin Kircher">

    <meta name="apple-mobile-web-app-capable" content="yes" />
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent" />

    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui">

    <link rel="stylesheet" href="css/reveal.css">
    <link rel="stylesheet" href="css/theme/black.css" id="theme">

    <!-- Code syntax highlighting -->
    <link rel="stylesheet" href="lib/css/zenburn.css">

    <!-- Printing and PDF exports -->
    <script>
      var link = document.createElement( 'link' );
      link.rel = 'stylesheet';
      link.type = 'text/css';
      link.href = window.location.search.match( /print-pdf/gi ) ? 'css/print/pdf.css' : 'css/print/paper.css';
      document.getElementsByTagName( 'head' )[0].appendChild( link );
    </script>

    <!--[if lt IE 9]>
    <script src="lib/js/html5shiv.js"></script>
    <![endif]-->
  </head>

  <body>

    <div class="reveal">

      <!-- Any section element inside of this container is displayed as a slide -->
      <div class="slides">
        <section>
          <h1>boost::any && boost::string_ref</h1>
          <h3>Two simple and useful libraries</h3>
          <p>
            <small>Created by <a href="https://github.com/bkircher">Ben</a> / <a href="http://twitter.com/predatorhat">@predatorhat</a></small>
          </p>
        </section>

        <section>
          <h2>boost::string_ref</h2>
          <p>
            #include &lt;boost/utility/string_ref.hpp&gt;
          </p>
          <p>
            <a href="http://www.boost.org/doc/libs/1_58_0/libs/utility/doc/html/string_ref.html">Documentation</a>
          </p>
        </section>

        <section>
          <h3>boost::string_ref</h3>
          <ul>
            <li>Introduced 1.53.0</li>
            <li>Now really mature</li>
            <li>Base on  Jeffrey Yaskin's N3442: <a href="http://www.open-std.org/jtc1/sc22/wg21/docs/papers/2012/n3442.html">string_ref: a non-owning reference to a string</a></li>
            <li>Which is based on LLVM's <a href="http://llvm.org/docs/doxygen/html/StringRef_8h_source.html">StringRef class</a></li>
            <li>Want to see that in C++17</li>
          </ul>
        </section>

        <section>
          <p>Basically just</p>
          <pre><code class="cpp">
template &lt;class CharT&gt; class string_ref
{
    // ...
    const CharT* ptr_;
    std::size_t len_;
};
          </code></pre>
        </section>

        <section>
          <h3>boost::string_ref</h3>
          <ul>
            <li>A read-only <em>view</em> into a std::string</li>
            <li>Similar interface to std::string</li>
            <li>Container requirements? It has a begin() and end()</li>
          </ul>
        </section>

        <section>
          <h3>boost::string_ref</h3>
          <p>
            Really cheap to copy
            <pre><code class="cpp">
boost::string_ref get_body() const noexcept
{
    auto node = document-&gt;find_node("body");
    if (node)
    {
        // Construct from a pointer, length pair
        return boost::string_ref(node-&gt;value(), node-&gt;value_size());
    }

    return boost::string_ref(); // This will have length() == 0
}
            </code></pre>
          </p>
        </section>

        <section>
          <h3>boost::string_ref</h3>
          <p>Drop in replacement for const char*</p>
            <pre><code class="cpp">
// Before:
void func(const char* str)
{
    assert(str);
    // str cannot contain \0-terminus
}

// After:
void func(boost::string_ref str)
{
  // No need to check nullptr dref
  // str can contain as much \0 as it likes
  // Note: we do not pass as const&amp;
}
            </code></pre>
        </section>

        <section>
        <h3>boost::string_ref</h3>
          <p>String-like operations</p>
            <pre><code class="cpp">
// Creates a new string_ref
string_ref substr(size_type pos, size_type n=npos) const;
bool starts_with(CharT c) const;
bool starts_with(string_ref x) const;
bool ends_with(CharT c) const;
bool ends_with(string_ref x) const;
            </code></pre>
        </section>

        <section>
          <h2>boost::any</h2>
          <p>
            Type erasure!
          </p>
        </section>

        <section>
          <h2>boost::any</h2>
          <p>
            #include &lt;boost/any.hpp&gt;
          </p>
          <p>
            <a href="http://www.boost.org/doc/libs/1_58_0/doc/html/any.html">Documentation</a>
          </p>
        </section>

        <section>
          <h3>Header &lt;boost/any.hpp&gt;</h3>
          <pre><code class="cpp">
namespace boost
{
    class bad_any_cast;
    class any;
    void swap(any&amp;, any&amp;);
    template &lt;typename T&gt; T any_cast(any&amp;);
    template &lt;typename T&gt; T any_cast(any&amp;&amp;);
    template &lt;typename T&gt; T any_cast(const any&amp;);
    template &lt;typename T&gt; const T* any_cast(const any*);
    template &lt;typename T&gt; T* any_cast(any*);
}
          </pre></code>
        </section>

        <section>
          <h3>boost::any in action</h3>
          <pre><code class="cpp">
int i = 42;
boost::any a;
a = i;
a = 2.0;

struct foo {};
a = foo{};

a = std::string("anything!");

void func(boost::any val)
{
    // Throws if val doesn't hold expected type
    std::string str = boost::any_cast&lt;std::string&gt;(val);

    std::cout &lt;&lt; str &lt;&lt; std::endl;
}

func(a); // Prints 'anything!'
          </code></pre>
        </section>

        <section>
          <h3>boost::any</h3>
          <p>
            Useful if start and end point know the type, but everything in
            between shouldn't
          </p>
        </section>

        <section>
          <h3>boost::any</h3>
            <pre><code class="cpp">
std::vector&lt;any&gt; something;
something.push_back(any(1729));
something.push_back(any(std::string("Coca Cola")));
something.push_back(any(web_socket("http://example.com/")));
whatever.set_something(std::move(something));

// Later in a galaxy far away...

auto container = whatever.get_something();
int carmichael_number = std::any_cast&lt;int&gt;(container[0]);
std::string drink = std::any_cast&lt;std::string&gt;(container[1]);
web_socket wsock = std::any_cast&lt;web_socket&gt;(container[2]);

            </code></pre>
        </section>

        <section>
          <h3>boost::any</h3>
          <p>
            Magic: templates, run-time polymorphism, and RTTI
          </p>
        </section>

        <section>
          <h3>boost::any implementation</h3>
          <pre><code class="cpp">
class any
{
    // ...

private:
    struct placeholder
    {
        virtual ~placeholder() = default;
        virtual const std::type_info&amp; type() const = 0;
        virtual placeholder* clone() = 0;
    };
    template &lt;class T&gt;
    struct holder : public placeholder
    {
        // ...
        T held;
    };
    placeholder* content;
};
          </code></pre>
        </section>


        <section>
          <pre><code class="cpp">
class any
{
public:
    any();
    any(const any&amp;);
    any(any&amp;&amp;);
    template &lt;typename T&gt; any(const T&amp;);
    template &lt;typename T&gt; any(T&amp;&amp;);
    any&amp; operator=(const any&amp;);
    any&amp; operator=(any&amp;&amp;);
    template &lt;typename T&gt; any&amp; operator=(const T&amp;);
    template &lt;typename T&gt; any&amp; operator=(T&amp;&amp;);
    ~any();

    // ...
};
          </code></pre>
        </section>

        <section>
          <h3>boost::any alternatives</h3>
          <ul>
            <li>void*</li>
            <li>Take a look at Boost.TypeErasure library</li>
            <li>If you happen to know the types up-front: boost::variant</li>
            <li>Always: custom solution for your problem at hand (common
              base-class, compile-time polymorphism)</li>
            <li>boost::spirit::hold_any (Not part of public API though)</li>
          </ul>
        </section>

        <section>
          <h3>boost::any performance</h3>
          <p>Complicated</p>
          <p>Good: function call overhead is exactly the same as with
          pointer-based inheritance (virtual function dispatch)</p>
          <p>Bad: a lot of heap allocations. Underlying type is copied a
          lot!</p>
        </section>

        <section>
          <h3>boost::any</h3>
          <table>
            <thead>
              <tr>
                <th>Pros</th>
                <th>Cons</th>
              </tr>
            </thead>
            <tbody>
              <tr>
                <td>Value semantics!</td>
                <td>Copying is quite expensive</td>
              </tr>
              <tr>
                <td>No need for new or delete</td>
                <td></td>
              </tr>
              <tr>
                <td>Works for nearly any type (only requirement: copyable)</td>
                <td></td>
              </tr>
            </tbody>
          </table>
        </section>

      </div>

    </div>

    <script src="lib/js/head.min.js"></script>
    <script src="js/reveal.js"></script>

    <script>

      // Full list of configuration options available at:
      // https://github.com/hakimel/reveal.js#configuration
      Reveal.initialize({
        controls: true,
        progress: true,
        history: true,
        center: true,

        transition: 'slide', // none/fade/slide/convex/concave/zoom

        // Optional reveal.js plugins
        dependencies: [
          { src: 'lib/js/classList.js', condition: function() { return !document.body.classList; } },
          { src: 'plugin/markdown/marked.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
          { src: 'plugin/markdown/markdown.js', condition: function() { return !!document.querySelector( '[data-markdown]' ); } },
          { src: 'plugin/highlight/highlight.js', async: true, condition: function() { return !!document.querySelector( 'pre code' ); }, callback: function() { hljs.initHighlightingOnLoad(); } },
          { src: 'plugin/zoom-js/zoom.js', async: true },
          { src: 'plugin/notes/notes.js', async: true }
        ]
      });

    </script>

  </body>
</html>
